#include <stdio.h>
#include <reg51.h>
#include <sys51.h>

near char out_hour, out_minute, out_second, out_mode12, out_pm;
near char out_date, out_month, out_year;
near char out_minus;
near unsigned long out_buffer;
void ss_delay(void){
    char i, j;
    for (i=0;i<0x10;i++){
        for (j=0;j<0x10;j++){;}
        }
}

void ss_initialize485(void){
    TMOD=TMOD&0x0f;
    TMOD=TMOD|0x20;
    SCON=0x50;
    PCON=PCON&0x7f;
    TH1=0xfd;
    TL1=0xfd;
    ET1=0;
    TR1=1;
}

void ss_sendbyte(char A){
    SBUF=A;
    while (TI==0){;}
    TI=0;
    ss_delay();
}

char ss_receivebyte(void){
    while (RI==0){;}
    RI=0;
    return SBUF;
}

void ss_clearstate(void){
    char i;
    for (i=0;i<4;i++){
    SBUF=0xff;
    while (TI==0){;}
    TI=0;
    ss_delay();
    }
}        

void ss_writecharacter(char addr485,char kolom, char karakter){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x10);
    ss_sendbyte(kolom);
    ss_sendbyte(karakter);  
}

char ss_readcharacter(char addr485,char kolom){  
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x11);
    ss_sendbyte(kolom);
    return ss_receivebyte();
}

void ss_setdisplay(char addr485,char stat, char display, char kontras, char blink){
    char input=0;
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x12);
    stat=stat&1;
    stat<<=5;
    display=display&3;
    kontras=kontras&7;
    kontras<<=2;
    blink=blink&1;
    blink<<=6;
    input=stat + display + kontras + blink;
    ss_sendbyte(input);
}
    
void ss_resetcounter(char addr485){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x13);
}

void ss_presetcounter(char addr485,char minus, unsigned long buffer){
    char i;
    char buf2;
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x14); 
    for(i=0;i<7;i++){
        buf2=buffer-(buffer/10)*10;
        buffer=buffer/10;
        ss_sendbyte(buf2);
    }
    ss_sendbyte(minus);
}

void ss_setrtctime(char addr485,char hour,char minute, char second, char mode12, char pm){
    char jam=0;
    mode12=mode12&1;
    mode12<<=7;
    pm=pm&1;
    pm<<=6;
    jam=hour + pm + mode12;
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x15);
    ss_sendbyte(jam);
    ss_sendbyte(minute);
    ss_sendbyte(second);
}   

void ss_setrtcdate(char addr485,char date, char month, char year){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x16);
    ss_sendbyte(date);
    ss_sendbyte(month);
    ss_sendbyte(year);
}

void ss_readrtctime(char addr485){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x17);
    out_mode12=ss_receivebyte();
    out_minute=ss_receivebyte();
    out_second=ss_receivebyte();
    out_hour=out_mode12&0x3f;
    out_mode12>>=6;
    out_pm=out_mode12&1;
    out_mode12>>=1;
}

void ss_readrtcdate(char addr485){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x18);
    out_date=ss_receivebyte();
    out_month=ss_receivebyte();
    out_year=ss_receivebyte();
}

void ss_readcounter(char addr485){
    unsigned long puluhan=1;
    char buf_array[8],i;
    out_buffer=0;
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x19);
    for(i=0;i<7;i++){
        buf_array[i]=ss_receivebyte();
    } 
    out_minus=ss_receivebyte();
    for(i=0;i<7;i++){
        out_buffer=out_buffer+buf_array[i]*puluhan;
        puluhan=puluhan*10;   
    }
}

void ss_writerom(char addr485,char romaddr, char data){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x1a);
    ss_sendbyte(romaddr);
    ss_sendbyte(data);
}

char ss_readrom(char addr485,char romaddr){   
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x1b);
    ss_sendbyte(romaddr);
    return ss_receivebyte();
}

void ss_countup(char addr485){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x1c);
}

void ss_countdown(char addr485){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x1d);
}

void ss_setaddress(char addr485,char addr){
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x1e);
    ss_sendbyte(addr);
}

char ss_readaddress(char addr485){  
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x1f);
    return ss_receivebyte();
}

void ss_cleardisplay(char addr485){    
    ss_clearstate();
    ss_sendbyte(addr485);
    ss_sendbyte(0x20);
}
        
void main(void){
    char addr=53;
    char i,j=5;
    unsigned long buffer=0,puluhan=1;
    ss_initialize485();
    _wait_ms(100);
    for(i=0;i<8;i++){
        ss_writecharacter(addr,i+1,i);
        ss_writerom(addr,i,i);
        _wait_ms(100);
    }
    for(i=5;i>0;i--){
        ss_setdisplay(addr,1,0,i,0);
        _wait_ms(500);
    }
    for(i=0;i<7;i++){
        buffer=buffer+(ss_readcharacter(addr,i+1)*puluhan);
        puluhan=puluhan*10;
    }
    ss_cleardisplay(addr);
    for(i=0;i<8;i++){
        ss_writecharacter(addr,5,ss_readrom(addr,i));
        _wait_ms(500);
    }
    ss_setdisplay(addr,1,1,5,0);
    ss_presetcounter(addr,0,buffer);
    _wait_ms(1000);
    ss_setaddress(addr,90);
    addr=90;
    _wait_ms(100);
    buffer=ss_readaddress(addr);
    _wait_ms(50);
    ss_presetcounter(addr,0,buffer);
    _wait_ms(1000);
    ss_countdown(addr);
    _wait_ms(1000);
    ss_countdown(addr);
    _wait_ms(1000);
    ss_countup(addr);
    _wait_ms(1000);
    ss_readcounter(addr);
    ss_resetcounter(addr);
    _wait_ms(1000);
    ss_presetcounter(addr,1,out_buffer);
    _wait_ms(1000);
    ss_setrtctime(addr,1,30,20,1,1);
    ss_setdisplay(addr,1,2,5,1);
    _wait_ms(1000);
    ss_setrtcdate(addr,26,6,83);
    ss_setdisplay(addr,1,3,5,1);
    _wait_ms(1000);
    ss_readrtcdate(addr);
    ss_setdisplay(addr,1,1,5,0);
    puluhan=10000;
    buffer=out_date*puluhan+out_month*100+out_year;
    ss_presetcounter(addr,0,buffer);
    _wait_ms(1000);
    ss_readrtctime(addr);
    buffer=out_hour*puluhan+out_minute*100+out_second;
    ss_presetcounter(addr,0,buffer);
    _wait_ms(100);
    ss_setaddress(addr,53);
    while(1);
}

