#include <stdio.h>
#include <reg51.h>
#include <sys51.h>

//SPI
#define clk      P1_B3  
#define dataout  P1_B2  
#define clr      P1_B1
#define datain   P1_B0  


near char out_hour, out_minute, out_second, out_mode12, out_pm; 
near char out_date, out_month, out_year;
near unsigned long out_buffer;
near char out_minus;
near char input_array[8];
near char output, out_char;
near char out_romdata, out_addr;

void ss_delay_clk (void){
    char i;
    for (i=0;i<150;i++){;}//150
}

void ss_delay_state (void){
    char i;
    for (i=0;i<50;i++){;}//50
}

void ss_clr_state (void){
    clk=1;
    clr=0;
    ss_delay_clk();
    clk=0;
    ss_delay_clk();
    clk=1;
    clr=1;
    ss_delay_state();
}

void ss_delay_write2read(void){
    char i,j;
    for (i=0;i<40;i++){
        for (j=0;j<200;j++){;};
        }
}

void ss_delay_write2read2(void){
    char i,j;
    for (i=0;i<20;i++){
        for (j=0;j<200;j++){;};
        }
}

void ss_write_byte(char input){
    char i;
    ss_delay_state();
    for (i=0;i<8;i++){
        input_array[i]=input&1;
        input>>=1;
        dataout=input_array[i];
        ss_delay_clk();
        clk=0;
        ss_delay_clk();
        clk=1;
        }
        
}

void ss_read_byte(void){//keluarannya berupa variabel eksternal ->output
    char i;
    output=0;
    for (i=0;i<8;i++){
        clk=0;
        ss_delay_clk();
        clk=1;
        ss_delay_clk();
        input_array[i]=datain;
        output=output|input_array[i]*0x80;
        if (i<7)
        output>>=1;
        };
    ss_delay_state();
}

void ss_deklarasi(char addr, char fungsi){
    ss_clr_state();
    ss_write_byte(addr);
    ss_write_byte(fungsi);    
}
void ss_writecharacter(char addr,char kolom,char karakter){
    ss_deklarasi(addr,0x10);
    ss_write_byte(kolom);
    ss_write_byte(karakter);
}

char ss_readcharacter(char addr,char kolom){
    ss_deklarasi(addr,0x11);
    ss_write_byte(kolom);
    ss_delay_write2read();
    ss_read_byte();
    return output;
}

void ss_setdisplay(char addr, char stat, char display, char kontras, char blink){
//STAT  = 0 : RTC stop
//STAT  = 1 : RTC run
//KONTRAS = 1 ... 5
//DISPLAY  = 0 : display karakter
//DISPLAY  = 1 : display counter  
//DISPLAY  = 2 : display RTC time  
//DISPLAY  = 3 : display RTC date
//BLINK    = 0 : not blink
//BLINK    = 1 : blinking
    char input=0;
    ss_deklarasi(addr,0x12);
    stat=stat&1;
    stat<<=5;
    display=display&3;
    kontras=kontras&7;
    kontras<<=2;
    blink=blink&1;
    blink<<=6;
    input=stat + display + kontras + blink;
    ss_write_byte(input);
    ss_delay_state();
}

void ss_resetcounter(char addr){
    ss_deklarasi(addr,0x13);
    ss_delay_state();
}

void ss_presetcounter(char addr,char minus, unsigned long buffer){
    char i;
    char buf2;
    ss_deklarasi(addr,0x14);
    ss_delay_state();
    for(i=0;i<7;i++){
        buf2=buffer-(buffer/10)*10;
        buffer=buffer/10;
        ss_write_byte(buf2);
    }
    ss_write_byte(minus);
    ss_delay_state();
}

void ss_setrtctime(char addr, char hour, char minute, char second, char mode12, char pm){
    char jam=0;
    mode12=mode12&1;
    mode12<<=7;
    pm=pm&1;
    pm<<=6;
    jam=hour + pm + mode12;
    ss_deklarasi(addr,0x15);
    ss_write_byte(jam);
    ss_write_byte(minute);
    ss_write_byte(second);
    ss_delay_state();
    P2=jam;
}

void ss_setrtcdate(char addr, char date, char month, char year){
    ss_deklarasi(addr,0x16);
    ss_write_byte(date);
    ss_write_byte(month);
    ss_write_byte(year);
    ss_delay_state();
}

void ss_readrtctime(char addr){
    ss_deklarasi(addr,0x17);
    ss_delay_write2read();
    ss_read_byte();
    out_mode12=output;
    ss_read_byte();
    out_minute=output;
    ss_read_byte();
    out_second=output;
    ss_delay_state();
    out_hour=out_mode12&0x3f;
    out_mode12>>=6;
    out_pm=out_mode12&1;
    out_mode12=out_mode12>>=1;
}

void ss_readrtcdate(char addr){
    ss_deklarasi(addr,0x18);
    ss_delay_write2read();
    ss_read_byte();
    out_date=output;
    ss_read_byte();
    out_month=output;
    ss_read_byte();
    out_year=output;
    ss_delay_state();
}

void ss_readcounter(char addr){
    unsigned long puluhan=1;
    char buf_array[8],i;
    out_buffer=0;
    ss_deklarasi(addr,0x19);
    ss_delay_write2read();
    ss_delay_write2read();
    for(i=0;i<7;i++){
        ss_read_byte();
        buf_array[i]=output;
    }
    ss_read_byte();
    out_minus=output;
    for(i=0;i<7;i++){
        out_buffer=out_buffer+buf_array[i]*puluhan;
        puluhan=puluhan*10;   
    }
}    

void ss_writerom(char addr, char ss_rom_addr, char ss_rom_data){
    ss_deklarasi(addr,0x1a);
    ss_write_byte(ss_rom_addr);
    ss_write_byte(ss_rom_data);
    ss_delay_state();
}
 
char ss_readrom(char addr,char ss_rom_addr){
    ss_deklarasi(addr,0x1b);
    ss_write_byte(ss_rom_addr);
    ss_delay_write2read();
    ss_read_byte();
    return output;
}

void ss_countup(char addr){
    ss_deklarasi(addr,0x1c);
    ss_delay_state();
}

void ss_countdown(char addr){
    ss_deklarasi(addr,0x1d);
    ss_delay_state();
}
       
void ss_setaddress(char addr,char dev_addr){
    ss_deklarasi(addr,0x1e);
    ss_write_byte(dev_addr);
    ss_delay_state();
}

char ss_readaddress(char addr){
    ss_deklarasi(addr,0x1f);
    ss_delay_write2read();
    ss_read_byte();
    return output;
    ss_delay_state();
}

void ss_cleardisplay(char addr){
    ss_deklarasi(addr,0x20);
    ss_delay_state();
}
void main(void){
    char addr=53;
    char i,j=5;
    unsigned long buffer=0,puluhan=1;
    for(i=0;i<8;i++){
        ss_writecharacter(addr,i+1,i);
        ss_writerom(addr,i,i);
        _wait_ms(100);
    }
    for(i=5;i>0;i--){
        ss_setdisplay(addr,1,0,i,0);
        _wait_ms(500);
    }
    for(i=0;i<7;i++){
        buffer=buffer+(ss_readcharacter(addr,i+1)*puluhan);
        puluhan=puluhan*10;
    }
    ss_cleardisplay(addr);
    for(i=0;i<8;i++){
        ss_writecharacter(addr,5,ss_readrom(addr,i));
        _wait_ms(500);
    }
    ss_setdisplay(addr,1,1,5,0);
    ss_presetcounter(addr,0,buffer);
    _wait_ms(1000);
    ss_setaddress(addr,90);
    addr=90;
    _wait_ms(100);
    buffer=ss_readaddress(addr);
    _wait_ms(50);
    ss_presetcounter(addr,0,buffer);
    _wait_ms(1000);
    ss_countdown(addr);
    _wait_ms(1000);
    ss_countdown(addr);
    _wait_ms(1000);
    ss_countup(addr);
    _wait_ms(1000);
    ss_readcounter(addr);
    ss_resetcounter(addr);
    _wait_ms(1000);
    ss_presetcounter(addr,1,out_buffer);
    _wait_ms(1000);
    ss_setrtctime(addr,1,30,20,1,1);
    ss_setdisplay(addr,1,2,5,1);
    _wait_ms(1000);
    ss_setrtcdate(addr,26,6,83);
    ss_setdisplay(addr,1,3,5,1);
    _wait_ms(1000);
    ss_readrtcdate(addr);
    ss_setdisplay(addr,1,1,5,0);
    puluhan=10000;
    buffer=out_date*puluhan+out_month*100+out_year;
    ss_presetcounter(addr,0,buffer);
    _wait_ms(1000);
    ss_readrtctime(addr);
    buffer=out_hour*puluhan+out_minute*100+out_second;
    ss_presetcounter(addr,0,buffer);
    _wait_ms(100);
    ss_setaddress(addr,53);
    while(1);
}